int holeRadius = 15;
int ballRadius = 10;

int minPower = 50;
int maxPower = 400;

// INITIATE THESE 2 VARIABLES, WHERE THE SPEEDNORM IS A NUMBER BETWEEN 0 AND 1, 
// AND FRICTION IS BIGGER THAN 1
float speedNorm;
float friction;

float holeX, holeY;
float ballX, ballY;
float velX, velY, velPower;
int state;
int STATE_RESET = 0;
int STATE_READY = 1;
int STATE_WINDUP = 2;
int STATE_SIMULATE = 3;
int STATE_CELEBRATE = 4;

void setup() {
  size(600, 500);
  noStroke();
  state = STATE_RESET;
  ballX = random(ballRadius, width - ballRadius);
  ballY = random(ballRadius, height - ballRadius);
  holeX = ballX;
  holeY = ballY;
}

void drawBoard() {
  background(95, 200, 70);
  fill(0);
  ellipse(holeX, holeY, holeRadius*2, holeRadius*2);
  fill(255);
  ellipse(ballX, ballY, ballRadius*2, ballRadius*2);
}

void draw() {

  if (state == STATE_RESET) {
    while (dist (ballX, ballY, holeX, holeY) <= 200) {
      holeX = random(holeRadius, width - holeRadius);
      holeY = random(holeRadius, height - holeRadius);
    }
    velPower = 0;
    state = STATE_READY;
  }

  if (state == STATE_READY && mousePressed && dist(mouseX, mouseY, ballX, ballY) <= ballRadius) {
      state = STATE_WINDUP;
  }

  if (state == STATE_CELEBRATE) {
    state = STATE_RESET;
    ballX = holeX;
    ballY = holeY;
  }
  drawBoard();

  if (state == STATE_WINDUP) {
    strokeWeight(2);
    stroke(200);
    line(ballX, ballY, mouseX, mouseY);
    stroke(0);
    noStroke();
    
    velPower = min(dist(ballX, ballY, mouseX, mouseY) + minPower, maxPower);

    if (!mousePressed) {
      
//      state = STATE_SIMULATE;    //UNCOMMENT when implementing motion; commented out to see line
      
      // CALCULATE THE BEGINNING X AND Y VELOCITIES OF THE BALL. THESE BEGINNING VELOCITIES 
      // WILL BE DEPENDENT ON velPower AND speedNorm, AND ARE CALCULATED DEPENDING ON THE 
      // LENGTH DRAGGED BY YOUR MOUSE BEFORE RELEASE



    } 
  }

  if (state == STATE_SIMULATE) {
    
    // PLACE THE MAJORITY OF YOUR CODE HERE: THIS INCLUDES EDGE TESTS, POSITION UPDATES, AND
    // VELOCITY POWER UPDATES DUE TO FRICTION 
    
    

    if (velPower <= 0) {
      state = STATE_READY;
    }

    if (dist(ballX, ballY, holeX, holeY) <= holeRadius) {
      state = STATE_CELEBRATE;
    }
  }
}

